searchData={"content_type":"text/markdown","items":[{"doc":"A Fastest WebP image thumbnail creator for Elixir.","ref":"Thumbp.html","title":"Thumbp","type":"module"},{"doc":"Create a thumbnail image","ref":"Thumbp.html#create/3","title":"Thumbp.create/3","type":"function"},{"doc":"iex> content = File.read!(\"./test/assets/images/sample.jpg\")\n    iex> Thumbp.create(content, 320, 240)\n    {:ok,  >}","ref":"Thumbp.html#create/3-examples","title":"Examples - Thumbp.create/3","type":"function"},{"doc":"Create a thumbnail image with options\n\n# Quality\n\nThe quality ranges from 0 to 100, defaulting to 75.\n\n# Target size\n\nYou can also specify a target size in bytes, although this will increase the processing time\nby approximately 20% to 80%.","ref":"Thumbp.html#create/4","title":"Thumbp.create/4","type":"function"},{"doc":"iex> content = File.read!(\"./test/assets/images/sample.jpg\")\n    iex> Thumbp.create(content, 320, 240, quality: 50)\n    iex> Thumbp.create(content, 320, 240, target_size: 12_000)","ref":"Thumbp.html#create/4-examples","title":"Examples - Thumbp.create/4","type":"function"},{"doc":"","ref":"Thumbp.html#t:body/0","title":"Thumbp.body/0","type":"type"},{"doc":"","ref":"Thumbp.html#t:height/0","title":"Thumbp.height/0","type":"type"},{"doc":"","ref":"Thumbp.html#t:quality/0","title":"Thumbp.quality/0","type":"type"},{"doc":"","ref":"Thumbp.html#t:target_size/0","title":"Thumbp.target_size/0","type":"type"},{"doc":"","ref":"Thumbp.html#t:width/0","title":"Thumbp.width/0","type":"type"},{"doc":"⚡ Thumbp: Ultra-Fast WebP Thumbnail Generator for Elixir\n========================================================\n\n[![Hex.pm](https://img.shields.io/hexpm/v/thumbp.svg)](https://hex.pm/packages/thumbp)\n[![Hexdocs.pm](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/thumbp/)\n[![Hex.pm](https://img.shields.io/hexpm/dt/thumbp.svg)](https://hex.pm/packages/thumbp)\n[![License](https://img.shields.io/hexpm/l/thumbp.svg)](https://github.com/ryochin/thumbp/blob/master/LICENSE)\n\nThumbp is a highly efficient thumbnail creation library for Elixir, designed to output with the [WebP](https://developers.google.com/speed/webp) image format for optimal speed and performance.\n\nNo need for ImageMagick, FFmpeg, libvips, or any other external libraries.\n\nInstallation\n------------\n\nThe package can be installed by adding `thumbp` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:thumbp, \"~> 0.1.0\"}\n  ]\nend\n```\n\nThen, run `mix deps.get`.\n\nUsage\n-----\n\nRead an image file and create a thumbnail:\n\n```elixir\niex> content = File.read!(\"./test/assets/images/sample.jpg\")\niex> Thumbp.create(content, 320, 240)\n{:ok,  >}\n```\n\nThe `width` and `height` parameters represent the potential maximum sizes, so they do not precisely define the actual dimensions of the image. This implies that the aspect ratio of the image will remain unchanged.\n\nAdjust the quality with an optional parameter ranging from 0 to 100 (default is 75):\n\n```elixir\niex> Thumbp.create(content, 160, 120, quality: 50)\n```\n\nYou can also define a target size, although which may increase the processing time by approximately 20-80%.\n\n```elixir\niex> Thumbp.create(content, 160, 120, target_size: 4_096)    # set to 4KB\n```\n\n**Note:** The `quality` and `target_size` options are exclusive.\n\nBenchmark\n---------\n\n* Input: 1280x960 JPEG (85% quality), 171.5KB\n* Output: 320x240 WebP (50% quality), ~2.2KB\n\n```sh\nmix run benchmark/benchmark.exs\n```\n\n```text\nName                      ips        average  deviation         median         99th %\nthumbp                  67.46       14.82 ms    ±10.06%       14.50 ms       22.86 ms\nimage (libvips)         19.41       51.52 ms    ±14.68%       50.01 ms       77.67 ms\n\nComparison:\nthumbp                  67.46\nimage (libvips)         19.41 - 3.48x slower +36.70 ms\n```\n\nDevelopment\n-----------\n\n#","ref":"readme.html","title":"⚡ Thumbp: Ultra-Fast WebP Thumbnail Generator for Elixir","type":"extras"},{"doc":"**Note:** This library requires the [Rust](https://www.rust-lang.org/) Toolchain for compilation.\n\nFollow the instructions at [www.rust-lang.org/tools/install](https://www.rust-lang.org/tools/install) to install Rust.\n\nVerify the installation by checking the `cargo` command version:\n\n```sh\ncargo --version\n# Should output something like: cargo 1.68.1 (115f34552 2023-02-26)\n```\n\nThen, set the `RUSTLER_PRECOMPILATION_EXAMPLE_BUILD` environment variable to ensure that local sources are compiled instead of downloading a precompiled library file.\n\n```sh\nRUSTLER_PRECOMPILATION_EXAMPLE_BUILD=1 mix compile\n```\n\nLicense\n-------\n\nThe MIT License","ref":"readme.html#prerequisites","title":"Prerequisites - ⚡ Thumbp: Ultra-Fast WebP Thumbnail Generator for Elixir","type":"extras"}]}